use axum::Json;
use axum_extra::extract::WithRejection;
use domain::dto::account::{AuthenticateGooleAccountReq, AuthenticateWithPassword};
use library::resp::{rejection::IRejection, response::{ ResData, ResResult}};
use validator::Validate;

pub async fn authenticate_google(
    WithRejection(Json(req), _): IRejection<Json<AuthenticateGooleAccountReq>>
) -> ResResult<ResData<()>> {
    req.validate()?;

    service::account::authenticate_google(req).await?;

    Ok(ResData::none())
}

pub async fn authenticate_with_password(
    WithRejection(Json(req), _): IRejection<Json<AuthenticateWithPassword>>
) -> ResResult<ResData<(String, String)>> {
    req.validate()?;

    service::sys_account::authenticate_with_password(req).await
}